/* TP 3 de LIFASR5, N. Louvet */
/* Expérimentations autour de la non fermeture de descripteur */

#include <iostream>
#include <cstring>

#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>

#include "rw-int.h"

void die(int e = 1, const std::string &msg = "") {
  if(msg != "") {
    std::cerr << "Erreur : " << msg << std::endl;
    std::cerr << std::strerror(errno) << std::endl;
  }
  else std::cerr << "Erreur : " << std::strerror(errno) << std::endl;
  exit(e);
}

using namespace std;

int main(void) {
  int pid, p[2];

  if( pipe(p) == -1 ) die();

  if( (pid = fork() ) == -1) die();

  if(pid > 0) { // processus père
    close(p[0]);
    for(int i = 1; i < 100; i++) {
      if(write_int(p[1], i) == -1) die();
      cout << "(père) " << i << endl << flush;
    }
    // décommenter pour fermer p[1] (descripteur pour l'écriture)
    // close(p[1]);
    if( waitpid(pid, NULL, 0) == -1) die();
    cout << "(père) terminaison normale" << endl << flush;
  }
  else { // processus fils
    int ret, n;
    // décommenter pour fermer p[1] (descripteur pour l'écriture)
    // close(p[1]);
    while((ret = read_int(p[0], n)) == 1) {
      if(n % 3 == 0)
        cout << "   (fils) " << n << endl << flush;
    }
    if (ret == 0) cout << "   (fils) le fd d'où je lis est fermé"
                       << endl << flush;
    if (ret == -1) die();
    close(p[0]);
    cout << "   (fils) terminaison normale" << endl << flush;
  }
  return 0;
}

